<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Subroutines to support delivery address per product
'*********************************************************************************

const dFirstName=1
const dLastName=2
const dAddress=3
const dCity=4
const dState=5
const dPostCode=6
const dcountry=7
const dCompany=8
const dPhone=9
const dEmail=10
const dDeliveryType=11
const Dshippingtype=12
const dshippingcost=13
const dComment=14
const dSignature=15
Const dDeliveryTime=16
const DeliveryAttributes=17
const DeliveryDelimiter=";"

sub CreateDeliveryAddress (deliveryarray)
deliveryarray(dfirstname)=strfirstname
deliveryarray(dlastname)=strlastname
deliveryarray(daddress)=straddress
deliveryarray(dcity)=strcity
deliveryarray(dstate)=strstate
deliveryarray(dpostcode)=strpostcode
deliveryarray(dcountry)=strcountry
deliveryarray(dCompany)=strCompany
deliveryarray(dPhone)=strPhone
deliveryarray(demail)=strEmail
deliveryarray(dDeliverytype)=DeliveryType
deliveryarray(dShippingCost)=ShippingCost
deliveryarray(dShippingtype)=ShippingMethod
deliveryarray(dComment)=DeliveryComment
deliveryarray(dSignature)=DeliverySignature
Deliveryarray(ddeliveryTime)=DeliveryTime
end sub

sub SetupDeliveryFields (Deliveryarray)
if not isarray(deliveryarray) then exit sub
Strfirstname=Deliveryarray(dFirstName)
strlastname=Deliveryarray(dLastName)
straddress=Deliveryarray(dAddress)
strcity=Deliveryarray(dCity)
strstate=Deliveryarray(dState)
strpostcode=Deliveryarray(dPostCode)
strcountry=Deliveryarray(DCountry)
strcompany=Deliveryarray(dCompany)
stremail=Deliveryarray(dEmail)
strphone=Deliveryarray(dPhone)
DeliveryType=DeliveryArray(DDeliveryType)
ShippingMethod=DeliveryArray(dShippingType)
ShippingCost=DeliveryArray(dShippingCost)
DeliveryComment=DeliveryArray(dComment)
DeliverySignature=DeliveryArray(dSignature)
DeliveryTime=deliveryarray(dDeliveryTime)
end sub

'add names to cart
sub GetDeliveryName (name, DeliveryArray)
dim shippingmethod
if Not isarray(DeliveryArray) then exit sub
if Deliveryarray(dDeliveryType)<> GetLang("LangDeliverySelf") then
   name=name & "<br />" & DeliveryFont &  GetLang("LangDeliveryAddress") & DeliveryFontEnd
   name=name & "<br />" & deliveryArray(dFirstName) & " " & DeliveryArray(dLastname)
   name=name & "<br />"&  deliveryArray(dAddress)
   name=name & "<br />" &  deliveryArray(dCity) & " "  & deliveryArray(dState) & " " & deliveryArray(dPostcode)
   AddDeliveryField "",name, deliveryArray(dCountry)
   AddDeliveryField "",name, deliveryArray(dCompany)
   AddDeliveryField  GetLang("LangCustPhone"),name, deliveryArray(dPhone)
   AddDeliveryField  GetLang("LangCustemail"),name, deliveryArray(demail)
else
   name=name & "<br />" & DeliveryFont &  GetLang("LangDeliverySelf") & DeliveryFontEnd
end if
AddDeliveryField  GetLang("LangDeliveryDate"),name, deliveryArray(dDeliveryTime)
ShippingMethod= deliveryArray(dShippingType)
if DeliveryArray(dShippingcost)<>"" then
   ShippingMethod = shippingmethod
end if
AddDeliveryField  GetLang("LangShippingMethod"),name,shippingmethod
AddDeliveryField  GetLang("LangCreate06"),name, deliveryArray(dComment)
AddDeliveryField  GetLang("LangDeliverySignature"), name, deliveryArray(dSignature)
end sub

sub AddDeliveryField (caption,name,value)
if value<>"" then
   if caption="" then
      name=name & "<br />" & value
   else
      name=name & "<br />" & DeliveryFont & caption & DeliveryFontEnd & "<br />" & value
   end if
end if
end sub

sub VerifyDeliveryAddress(rc)
rc=0
'See if each product that requires a delivery address, has one
dim scartitem, ArrCart, i, deliveryarray, deliveryrequired
if GetConfig("xDeliveryRequired")<>"Yes" then exit sub
scartItem = GetSess("CartCount")
ArrCart = GetSessA("CartArray")

'700 - product bundles
dim bundleparentid

'go through all products
for i = 1 to scartItem
   '700 - product bundles
   bundleparentid = ArrCart(cbundleparentid,i)
   if trim(bundleparentid) = "" then
      Deliveryarray=ArrCart(cDelivery,i)
      if not isarray(deliveryArray) then
         rc=4
         exit sub
      end if
   end if
next
rc=0
end sub

sub ConvertDeliveryToString(DeliveryArray, ostring)
dim i
ostring=""
if not isarray(deliveryarray) then exit sub
for i = 1 to DeliveryAttributes-1
   if i=1 then
      ostring=deliveryarray(i)
   else
      ostring=ostring & DeliveryDelimiter & Deliveryarray(i)
   end if
next
end sub

sub ConvertDeliveryToArray(DeliveryArray,istring)
redim DeliveryArray(DeliveryAttributes)
dim words(30),wordcount,Delimiter,i
Delimiter=DeliveryDelimiter
ParseRecord istring, words, wordcount, delimiter
wordcount=wordcount-1
for i =0  to wordcount
   Deliveryarray(i+1)=words(i)
next
end sub
%>