<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<!--#include file="shopformatorder.asp"-->
<!--#include file="shopcartformat.asp"-->
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' called by shopstatus to view or restore an order
'*********************************************************************************

const RestoreRedirectUrl = "shopaddtocart.asp"
dim customerid
CustCheckAdmin Customerid
dim RestOrders, restoreRealLinks
dim View, restore, Restoid
dim Downloadflag

'6.50 - precautionary security fix
Restore = CleanChars(Request("Restore"))
View = CleanChars(Request("View"))

RestOid = request("oid")
if not isnumeric(restoid) then
   ShopError GetLang("langOrderNone") & "<br />"
end if
LocateOrder restoid, customerid
if SError = "" then
   if Restore<>"" then
      PerformRestoreOrder restoid
      ShopPageHeader
   else
      FormatRestore
      Formatdownloads
      ShopFormatOrder dbc, restoid, ""
   end if
else
   ShopPageHeader
end if
if SError<>"" then
   DisplayErrors
end if
ShopPageTrailer
ShopCloseDatabase dbc

' see if order exists
' If yes see if downloads allowed
sub LocateOrder (oid, cid)
   dim sql
   strsql = "select * from orders where orderid=" & oid & " AND ocustomerid=" & cid
   Set Orders = Server.CreateObject("ADODB.Recordset")
   Orders.open strsql, dbc, adOpenDynamic, adLockOptimistic
   if Orders.eof then
      SError = GetLang("langOrderNone") & "<br />"
   end if
   if SError = "" then
      ValidatePurchase orders, rc
      if rc = 0 then
         downloadflag = true
      else
         downloadflag = false
      end if
   end if
   CloseRecordSet Orders
end sub

sub DisplayErrors
   ShopWriteError SError
end sub

sub PerformRestoreOrder (oid)
   strsql = "select * from orders where orderid=" & oid
   Set RestOrders = Server.CreateObject("ADODB.Recordset")
   RestOrders.open strsql, dbc, adOpenDynamic, adLockOptimistic
   RestoreItems oid, dbc
   if SError<>"" then
      restorders.close
      set restorders = nothing
      exit sub
   end if
   GetCustomerSessionData
   RestoreShipping RestOrders
   UpdateCustomerSessionData
   Restorders.close
   set Restorders = nothing
   if RestoreRedirecturl<>"" then
      ResponseRedirect RestoreRedirectUrl
   end if
   SError = GetLang("langCartRestored") & " " & oid
end sub

sub RestoreItems (oid, dbc)
   dim restorenewprice
   dim scartitem, ArrCart, nameincart, quantity
   dim CatalogId, dualprice, strsql, category
   dim ProductAddress, DeliveryArray, weight, image
   dim catsql, catrs, originalprice, cname, stock
   dim rsupplierid, rfeatures
   dim pos
   dim DiscountPrice
   strSQL = "select * FROM oitems where orderid = " & oid
   Set items = Server.CreateObject("ADODB.Recordset")
   items.open strSQL, dbc, adOpenDynamic, adLockOptimistic
   if items.eof then
      items.close
      set items = nothing
      SError = GetLang("langFormatMissing")
      exit sub
   end if
   ArrCart = GetSessA("CartArray")
   scartItem = GetSess("CartCount")
   do while not items.eof
      nameincart = items("itemname")
      productaddress = items("address")
      pos = instr(nameincart, GetLang("langGiftCertificate"))
      if pos>0 then
         SError = GetLang("langGiftFail")
         items.close
         set items = nothing
         exit sub
      end if
      quantity = items("numitems")

      CatalogId = items("CatalogId")
      dualprice = items("dualprice")
      rsupplierid = items("supplierid")
      rfeatures = items("features")
      category = 0
      catsql = "select * from products where CatalogId=" & CatalogId
      Set catrs = Server.CreateObject("ADODB.Recordset")
      catrs.open catsql, dbc, adOpenDynamic, adLockOptimistic
      if not catrs.eof then
         '6.09 - fix for restore order retaining old price, rather than getting it from the products table
         unitprice = catrs("cprice")

         category = catrs("ccategory")
         weight = catrs("weight")
         image = catrs("cimageurl")
         cname = catrs("cname")
         cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", CatalogId, cname)
         stock = catrs("cstock")
		 strgroupfordiscount=catrs("groupfordiscount")

		 'Check if customer is entitled to any discounts
		 ShopCustomerPrices catrs,catalogid, category, unitprice, restorenewprice, lngDiscount
		 if trim(restorenewprice) <> "" then
		    unitprice=restorenewprice
         end if

         CloseRecordSet catrs
         originalprice = unitprice
         GetOriginalprice dbc, CatalogId, originalprice
         scartitem = scartitem + 1
         ArrCart(cProductid, scartItem) = CatalogId
		 ArrCart(cCategory, scartItem) = category
		 arrCart(cGroupDiscount,scartItem) = strgroupfordiscount
		 
		 'fix - quantity discount for restore orders
		 CalculateUserPrice unitprice, Quantity, DiscountPrice, ArrCart, scartitem
		 if trim(DiscountPrice) <> "" then
		    unitprice = DiscountPrice
         end if

         ArrCart(cProductCode, scartItem) = ""
         ArrCart(cProductname, scartItem) = NameInCart
         ArrCart(cQuantity, scartItem) = clng(quantity)
         ArrCart(cOriginalPrice, scartItem) = Originalprice
         ArrCart(cUnitPrice, scartItem) = UnitPrice
         ArrCart(cProductimage, scartItem) = Image
         ArrCart(cProductweight, scartItem) = Weight
         ArrCart(cProductMininame, scartItem) = cname
         ArrCart(cStocklevel, scartItem) = Stock
         if GetConfig("XdualPrice") = "Yes" then
            ArrCart(cDualPrice, scartItem) = Dualprice
         else
            ArrCart(cDualPrice, scartItem) = 0
         end if
         if GetConfig("XDeliveryAddress") = "Yes" and not isnull(ProductAddress) then
            ConvertDeliveryToArray Deliveryarray, Productaddress
            ArrCart(cDelivery, scartItem) = DeliveryArray
         end if
         
         ArrCart(cDiscount, scartItem) = ""
         ArrCart(cProductfeatures, scartItem) = rfeatures
         ArrCart(csupplierid, scartItem) = rsupplierid
      else
         SError = SError & GetLang("langnolongeravailable") & "<br /><br /><a href=""shopaddtocart.asp"">" & GetLang("langcommonviewcart") & "</a>"
      end if
      items.movenext
   loop
   
   '701 - 2011.11.15 - Bug Fix: Restore cart is not working with database sessions
   SetSess "CartCount", scartitem
   SetSessA "CartArray", ArrCart
   
   items.close
   set items = nothing
end sub

sub RestoreShipping (RS)
   strshipname = rs("oshipname")
   strshipaddress = rs("oshipaddress")
   strshiptown = rs("oshiptown")
   strshipzip = rs("oshipzip")
   strshipstate = rs("oshipstate")
   strshipcountry = rs("oshipcountry")
   strshipcompany = rs("oshipcompany")
   strshipmethodtype = rs("oshipmethodtype")
   strshipcost = rs("oshipcost")
end sub

sub FormatRestore
   ShopPageHeader
   if GetConfig("xallowRestoreOrder")<>"Yes" then exit sub
%>
<a href="shoprestoreorder.asp?oid=<%=restoid%>&restore=yes"><%=GetLang("langrestoreorder")%></a>
<%
   if GetConfig("xRMAallowed") = "Yes" then
      response.write "&nbsp;"
      response.write "<a href=""shoprma.asp?oid=" & restoid & """>" & GetLang("langrma") & "</a>"
   end if
   response.write "<br />"
end sub

sub Formatdownloads
   dim rs, sql, oirs, productCatalogId, downloadcount
   if GetConfig("xdownloads")<>"Yes" then exit sub
   if downloadflag = false then exit sub
   Restorereallinks = GetConfig("xdownloadreallinks")
   downloadcount = 0
   strSQL = "select * FROM oitems where orderid = " & restoid
   Set oiRS = Server.CreateObject("ADODB.Recordset")
   oiRS.open strSQL, dbc, adOpenDynamic, adLockOptimistic
   do while not oiRS.eof
      ProductCatalogId = oirs("CatalogId")
      GenerateSecureHyperlink dbc, ProductCatalogId, downloadcount, restoid, GetSess("customerid"), oirs
      oiRS.MoveNext
   loop
   CloseRecordSet oirs
   response.write "<br />"
end sub

' generate secure hyperlink to shopdownload.asp
sub GenerateSecureHyperlink (dbc, CatalogId, count, orderid, customerid, oitems)
   dim productlink, oid, link
   dim item, features, featurename
   productlink = GetConfig("xendoforderhyperlinkfield")
   dim productsql, rs, cname, filename
   if CatalogId = 0 then exit sub
   Productsql = "select * from products where CatalogId=" & CatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open productsql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof then
      CloseRecordSet rs
      exit sub
   end if
   link = rs(productlink)
   if isnull(link) then
      CloseRecordSet rs
      exit sub
   end if
   cname = rs("cname")
   cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", CatalogId, cname)
   item = oitems("orderitemid")
   if GetConfig("xdownloadfeature") = "Yes" then
      features = oitems("features")
      if not isnull(features) then
         featurename = Getfeaturename(dbc, features)
         cname = cname & " " & featurename
      end if
   end if
   Restorereallinks = GetConfig("xdownloadreallinks")
   if RestorerealLinks = "Yes" then
      filename = "shopdownloadreal.asp?oid=" & orderid & "&CatalogId=" & CatalogId & "&item=" & item
   else
      filename = "shopdownload.asp?oid=" & orderid & "&CatalogId=" & CatalogId & "&item=" & item
   end if
   if count = 0 then
      ShopWriteHeader GetLang("LangdownloadFiles")
   end if
%>
<br />
<a href="<%=filename%>"><%=cname%></a><br />
<%
   CloseRecordSet rs
   count = count + 1
end sub

' Get original price
sub Getoriginalprice (dbc, CatalogId, price)
   dim rs, sql
   if GetConfig("xquantityprices") = "No" then exit sub
   sql = "select * from products where CatalogId=" & CatalogId
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      price = rs("cprice")
   end if
   CloseRecordSet rs
end sub

' See if payment type matches any of the valid payments allowed
sub ValidatePurchase (orderRS, rc)
   dim cardtype, cardarray(20), cardcount, paymenttype, i
   rc = 0
   CardType = GetConfig("xendofordervalidpayments")
   paymenttype = ucase(orderrs("ocardtype"))
   if cardtype = "" then
      exit sub
   end if
   ParseRecord cardtype, cardarray, cardcount, ","
   for i = 0 to cardcount -1
      if ucase(cardarray(i)) = paymenttype then
         exit sub
      end if
   next
   rc = 4
end sub

function getfeaturename(dbc, strfeatures)
   dim features(10), featurecount, frs, fsql, featurename
   ParseRecord strfeatures, features, featurecount, ","
   fsql = "select * from prodfeatures where id=" & features(0)
   Set frs = Server.CreateObject("ADODB.Recordset")
   frs.open fsql, dbc, adOpenDynamic, adLockOptimistic
   featurename = frs("featurename")
   CloseRecordSet frs
   getfeaturename = featurename
end function
%>