<%option explicit%>
<%response.buffer=true%>
<!--#include file="shop$db.asp"-->
<%ShopOpenDatabase dbc%>
<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' TopSellers routines
' 700 - new / topseller products enhancement - 2010.03.01
'*********************************************************************************

dim howmanyitems
howmanyitems = cleanchars(request("howmanyitems"))

if GetConfig("xtopsellers") <> "Yes" then response.end
if GetConfig("xlogonrequired") = "Yes" then
   if GetSess("Login") = "" then
      response.end
   end if
end if
if GetConfig("xshopclosed") = "Yes" then
   if GetSess("Login") = "Force" then
      response.end
   end if
   if GetSess("shopadmin") = "" then
      ShopError GetLang("Langshopclosed")
   end if
end if
   
if isnumeric(howmanyitems) = false or howmanyitems = "" then
   howmanyitems = 10
else
   howmanyitems = int(howmanyitems)
end if

' Find all products sold
dim strsql, useorderdb
dim rs

strsql = "select o.CatalogId, sum(o.numitems) as sumofnumitems"
strsql = strsql & " from oitems o "
if GetConfig("xtopsellersprocessedonly") = "Yes" then
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=1"
   else
      strsql = strsql & ", orders p WHERE o.orderid=p.orderid and p.oprocessed=TRUE"
   end if
end if
strsql = strsql & " GROUP BY o.CatalogId"
if instr(ucase(xdatabasetype), "MYSQL") > 0 then
   strsql = strsql & " ORDER BY sumofnumitems DESC"
else
   strsql = strsql & " ORDER BY sum(o.numitems) DESC"
end if

Set rs = Server.CreateObject("ADODB.Recordset")
rs.open strsql, dbc, adOpenDynamic, adLockOptimistic   
dim catalogidstr
catalogidstr = ""
generatetopsellersql rs, howmanyitems,catalogidstr
CloseRecordSet rs
strsql = "select * from products where catalogid in ("& catalogidstr &")"
SetSess "sql", strsql
ShopCloseDatabase dbc
response.redirect "shopdisplayproducts.asp?search=yes&cat=Top Selling Products"

sub generatetopsellersql (rs, ilimit,catalogidstr)
   dim count, fieldvalue, prs, scriptresponder, filename, lngCatalogId, ordercount, hideprod
   dim strcname, strhcname, lnghigherCatalogId,psql
   dim limit
   
   if ilimit <> "" then
      limit = ilimit
   else
      limit = cint(GetConfig("xtopsellerlimit"))
      if limit = "" or isnull(limit) then
         limit = 5
      end if
   end if
   count = 0
   do while not rs.eof and count < limit
      hideprod = false
      lngCatalogId = rs("CatalogId")

      psql = "select cname, higherCatalogId, hide from products where CatalogId = " & lngCatalogId
      Set prs = Server.CreateObject("ADODB.Recordset")
      prs.open psql, dbc, adOpenDynamic, adLockOptimistic
      if not prs.eof then
         if prs("higherCatalogId") > "" then
            lnghigherCatalogId = prs("higherCatalogId")
         else
            lnghigherCatalogId = ""
         end if
      end if
      CloseRecordSet prs

      '6.50 - added 'childhide' to sql below to stop hidden child products from showing
      if lnghigherCatalogId > "" then
         '6.50.4 Bugs Fix - 08 October 2008
         psql = "select hp.ccategory, hp.CatalogId, hp.cimageurl, p.cprice, p.cname AS cname, p.cstock as cstock, hp.cname AS hpcname, hp.hide AS hphide, p.productmatch, p.customermatch, p.hide AS childhide, hp.cdescription, p.pother1 as pother1 from products p, products hp, prodcategories cc, categories c where p.higherCatalogId = hp.CatalogId AND p.CatalogId =" & lngCatalogId
		 psql = psql & " and cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
      else
         psql = "select *, hide AS hphide, hide AS childhide from products p, prodcategories cc, categories c where p.CatalogId=" & lngCatalogId
         psql = psql & " and cc.intCatalogId=p.CatalogId and cc.intcategoryid=c.categoryid "
      end if

      '700 - generate sql by product criteria - 2010.04.03
      generateproductstdcriteriasql psql, "p.", "c.", "generateproductmatchsqlsubs"
   
      Set prs = Server.CreateObject("ADODB.Recordset")
      prs.open psql, dbc, adOpenDynamic, adLockOptimistic
	  
      if not prs.eof then
         '6.50 - added 'childhide' to sql below to stop hidden child products from showing
         if ((prs("hphide") = 1) or (lcase(prs("hphide")) = "true")) or ((prs("childhide") = 1) or (lcase(prs("childhide")) = "true")) then
            hideprod = true
         end if

         if GetConfig("xstockcontrol") = "Yes" then
            dim stocklowlevel
            if GetConfig("xstocklow") = "" or isnull(GetConfig("xstocklow")) then
               stocklowlevel = 0
            else
               stocklowlevel = GetConfig("xstocklow")
            end if

            '6.09 - If stockcontrol is on and the stock field of product was blank, there was an error here.
            dim dbproductstock
            dbproductstock = prs("cstock")
            if isnull(dbproductstock) or dbproductstock = "" then
               dbproductstock = 0
            end if

            if cint(dbproductstock) <= cint(stocklowlevel) then
               hideprod = true
            end if
         end if

 	     if count = 0 then
		    catalogidstr = prs("catalogid")
		 else
		    catalogidstr = catalogidstr & "," & prs("catalogid")
		 end if
         count = count + 1
      end if
      CloseRecordSet prs
      rs.movenext
   loop
end sub
%>