<%
sub loadcenterselections (containername,containerboxid,htmldivname,mainsidename)
   select case lcase(containername)
      case "empty"
	     gencenteremptytable containerboxid,mainsidename,htmldivname
      case "contentpage"
	     gencentercontentpagetable containerboxid,mainsidename,htmldivname
      case "news"
		 genglobalnewstable containerboxid,mainsidename,htmldivname,"center"
	  case "blogs"
	     genglobalblogstable containerboxid,mainsidename,htmldivname,"center"
      case "newproducts"
	     gencenternewproductstable containerboxid,mainsidename,htmldivname
      case "randomproducts"
	     genglobalrandomproductstable containerboxid,mainsidename,htmldivname,"center"
	  case "freetext"
	     '700- 2010.04.05 - code enhancement
	     genglobalfreetexttable containerboxid,mainsidename,htmldivname,"center"
	  '700 - layout manager enhancement - 2010.03.01
	  case "freeflash"
	     genglobalfreeflashtable containerboxid,mainsidename,htmldivname,"center"
	  case "freeimage"
	     genglobalfreeimagetable containerboxid,mainsidename,htmldivname,"center"
	  '700- 2010.04.05 - twitter
	  case "twitter"
	     genglobaltwittertable containerboxid,mainsidename,htmldivname,"center"

	  case else
	     'debugwrite containername
   end select
end sub

sub addcenterbox
   '700 - 2010.06.17 - Bug Fix: Layout manager - not able to create new record if creating same components on the row
   resetcontainerboxlastid

   dim sqlrs,strsql,boxcnt,leftorright
   leftorright = cleanchars(request("leftorright"))
   dim donoffstring
   dim tempnamedesc
   boxcnt = 1

   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
   strsql="select id,otheroptions2,containername,containerdivname,labelfield from containerbox where containerdivname = "& sqlserverprefixn &"'"& leftorright &"' "
   GenLayoutMgrStorematchSQL "and", strsql
   strsql = strsql & "order by otheroptions2 asc"

   Set sqlrs = Server.CreateObject("ADODB.Recordset")
   sqlrs.open strsql, dbc, adopenkeyset, adlockoptimistic
   do while not sqlrs.eof
      donoffstring = getonoff(getotheroptions1 (sqlrs("containerdivname"),"",sqlrs("id")))
	  tempnamedesc = getcontainernamedesc(sqlrs("containername"),sqlrs("containerdivname"))
      htmlwrite "<div id=""hp"& leftorright &""& boxcnt &""" class="""& leftorright &""">"
	  htmlwrite "<div class=""boxtitle""><div style=""float:left;"">"& tempnamedesc &"</div>"& donoffstring &"<div style=""clear:both;""></div></div>"
	  htmlwrite "<div class=""boxfuncdesc"">"
	  htmlwrite "<div>"& sqlrs("labelfield") &"</div>"
	  htmlwrite "<div>ID #" & sqlrs("id") &"</div>"
	  if trim(sqlrs("otheroptions2")) <> "" and isnull(sqlrs("otheroptions2")) = false then htmlwrite "<div>Seq #" & sqlrs("otheroptions2") &"</div>"
	  htmlwrite "<a href=""javascript:expandcenterbox('"& sqlrs("id") &"','hp"& leftorright &""& sqlrs("id") &"');"">"& GetLang("LangCommonEdit") &"</a>"
	  htmlwrite "&nbsp;&nbsp;"
	  htmlwrite "<a href=""javascript:deletecenterbox('"& sqlrs("id") &"','hp"& leftorright &""& sqlrs("id") &"');"">"& GetLang("langcommondelete") &"</a>"
	  htmlwrite "</div>"
	  htmlwrite "<div id=""hp"& leftorright &""& sqlrs("id") &""" name=""hp"& leftorright &""& sqlrs("id") &""" class=""editbox""></div>"
	  htmlwrite "</div>"
	  boxcnt = boxcnt + 1
	  sqlrs.movenext
   loop
   closerecordset sqlrs
%>
   <div id="hp<%=leftorright%>empty" class="<%=leftorright%>">
      <div class="boxtitle"><%=GetLang("langcommonempty")%></div>
      <div class="boxfuncdesc"><a href="javascript:expandcenterbox('empty','hp<%=leftorright%>empty2');"><%=GetLang("LangCommonEdit")%></a></div>
      <div id="hp<%=leftorright%>empty2" name="hp<%=leftorright%>empty2" class="editbox"></div>
   </div>
   <input type="button" class="boxfuncbtn" onclick="javascript:addcenterbox('<%=leftorright%>');" value="<%=GetLang("langhpmgraddbox")%>" />
   <div style="clear:both"></div>
<%
end sub

sub loadcenterbox
   dim containerboxid,htmldivname
   containerboxid = cleanchars(request("id"))
   htmldivname = cleanchars(request("htmldivname"))
   
   dim containername
   
   if lcase(trim(containerboxid)) = "empty" then
      containername = "empty"
   else
      containername = getcontainername(containerboxid)
   end if

   dim divname
   divname = "centerbox"
      
   setsess "hpmgrprocategorylist",""

   '700 - layout manager enhancement - 2010.03.30
   setsess "hpmgrprocategorylistsidebox",""

   loadcenterselections containername,containerboxid,htmldivname,divname
end sub

sub savecenterbox (containername)
   dim id,otheroptions1,otheroptions2,divname,labelfield,otheroptions3,otheroptions4,otheroptions5,otheroptions6
   dim otheroptions7,otheroptions8,otheroptions9,otheroptions10,otheroptions11,otheroptions12,otheroptions13,otheroptions14
   dim otheroptions15,otheroptions16,otheroptions17,otheroptions18,otheroptions19,otheroptions20,otheroptions21,otheroptions22,otheroptions23,otheroptions24,otheroptions25
   id = cleanchars(request("id"))

   '700 - 2010.04.08 - get last containerbox id
   if lcase(trim(id)) = "empty" then
      if trim(getsess(containername & "lastid")) <> "" then
	     id = getsess(containername & "lastid")
		 setsess "lastid", ""
	  end if
   end if

   otheroptions1 = cleanchars(request("otheroptions1"))
   otheroptions2 = cleanchars(request("otheroptions2"))
   otheroptions3 = cleanchars(request("otheroptions3"))

   '701 - 2012.04.02 - Bug Fix: Layout Manager: Center Body not able to save double char to content header field
   if lcase(containername) = "contentpage" then
      otheroptions4 = URLDecode(JSURLDecode(cleanchars(request("otheroptions4"))))
   else
   otheroptions4 = cleanchars(request("otheroptions4"))
   end if

   if lcase(containername) = "contentpage" then
      '700 - 2010.05.05 - Bug Fix: Layout Manager - JS double bytes issues.
      otheroptions5 = replace(URLDecode(JSURLDecode(request("otheroptions5"))),"&amp;","&")
	  otheroptions5 = replace(otheroptions5,"%uFFFD","'")
   else
      otheroptions5 = cleanchars(request("otheroptions5"))
   end if
   otheroptions6 = cleanchars(request("otheroptions6"))
   otheroptions7 = request("otheroptions7")
   otheroptions8 = request("otheroptions8")
   otheroptions9 = request("otheroptions9")
   otheroptions10 = request("otheroptions10")
   otheroptions11 = request("otheroptions11")
   otheroptions12 = request("otheroptions12")
   otheroptions13 = request("otheroptions13")
   otheroptions14 = request("otheroptions14")
   otheroptions15 = request("otheroptions15")
   otheroptions16 = request("otheroptions16")
   otheroptions17 = request("otheroptions17")
   otheroptions18 = request("otheroptions18")
   otheroptions19 = request("otheroptions19")
   otheroptions20 = request("otheroptions20")
   otheroptions21 = request("otheroptions21")
   otheroptions22 = request("otheroptions22")
   otheroptions23 = request("otheroptions23")
   otheroptions24 = request("otheroptions24")
   otheroptions25 = request("otheroptions25")
   
   '700 - 2010.05.05 - Bug Fix: Layout Manager - JS double bytes issues.
   labelfield = replace(URLDecode(JSURLDecode(request("labelfield"))),"&amp;","&")

   divname = cleanchars(request("divname"))
   
   dim resizeimage
   resizeimage = cleanchars(request("resizeimage"))
   
   if lcase(trim(containername)) = "randomproducts" then otheroptions4 = getsess("hpmgrprocategorylist")
   
   if trim(id) = "" then exit sub
   if isnumeric(id) = false and lcase(trim(id)) <> "empty" then exit sub

   if lcase(containername) = "freeimage" then
      dim ologowidth,ologoheight
	  
	  if lcase(trim(id)) <> "empty" then
         ologowidth = getotheroptions4 (divname,"",id)
         ologoheight = getotheroptions5 (divname,"",id)
      else
	     ologowidth = 0
		 ologoheight = 0
      end if
      doresizeimage otheroptions3,resizeimage,ologowidth,otheroptions4,ologoheight,otheroptions5
   end if

   if lcase(containername) = "contentpage" then
	  'save content table
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      dim pageid,logoimage,message2,message
      gethomepagedetails pageid,logoimage,message2,message

      sql = ""
      sql = sql & "update content "
      sql = sql & "set contentimage = "& sqlserverprefixn &"'"& tosql(otheroptions3,"Text") &"', "
      sql = sql & "message = "& sqlserverprefixn &"'"& tosql(otheroptions4,"Text") &"', "
	  sql = sql & "message2 = "& sqlserverprefixn &"'"& tosql(otheroptions5,"Text") &"' "
	  sql = sql & "where contentid = "& pageid &" "
	  dbc.execute (sql)
   end if

   if lcase(containername) = "newproducts" then
	  'save content table
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = ""
      sql = sql & "update "& xconfigtable &" "
      sql = sql & "set fieldvalue = "& sqlserverprefixn &"'"& tosql(otheroptions4,"Text") &"' "
	  sql = sql & "where fieldname = 'xNewProductsfrontpagemaxrecords' "
	  dbc.execute (sql)

      sql = ""
      sql = sql & "update "& xconfigtable &" "
      sql = sql & "set fieldvalue = "& sqlserverprefixn &"'"& tosql(otheroptions5,"Text") &"' "
	  sql = sql & "where fieldname = 'xNewProductDuration' "
	  dbc.execute (sql)
   end if

   if lcase(containername) = "randomproducts" then
	  'save content table
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = ""
      sql = sql & "update "& xconfigtable &" "
      sql = sql & "set fieldvalue = "& sqlserverprefixn &"'"& tosql(otheroptions5,"Text") &"' "
	  sql = sql & "where fieldname = 'xrandomproductlimit' "
	  dbc.execute (sql)
   end if

   if validcontainerid(id) = true then
      'do update
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = ""
      sql = sql & "update containerbox "
      sql = sql & "set otheroptions1 = "& sqlserverprefixn &"'"& tosql(otheroptions1,"Text") &"', "

      '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
      UpdateLayoutMgrStorematchSQL ",", sql

      sql = sql & "otheroptions2 = "& sqlserverprefixn &"'"& tosql(otheroptions2,"Text") &"', "
	  
	  if lcase(containername) <> "contentpage" then
         sql = sql & "otheroptions3 = "& sqlserverprefixn &"'"& tosql(otheroptions3,"Text") &"', "
		 if lcase(containername) <> "newproducts" then
            sql = sql & "otheroptions4 = "& sqlserverprefixn &"'"& tosql(otheroptions4,"Text") &"', "
			if lcase(containername) <> "randomproducts" then
	           sql = sql & "otheroptions5 = "& sqlserverprefixn &"'"& tosql(otheroptions5,"Text") &"', "
			end if
		 end if
	  end if
	  
	  sql = sql & "otheroptions6 = "& sqlserverprefixn &"'"& tosql(otheroptions6,"Text") &"', "
	  sql = sql & "otheroptions7 = "& sqlserverprefixn &"'"& tosql(otheroptions7,"Text") &"', "
	  sql = sql & "otheroptions8 = "& sqlserverprefixn &"'"& tosql(otheroptions8,"Text") &"', "
	  sql = sql & "otheroptions9 = "& sqlserverprefixn &"'"& tosql(otheroptions9,"Text") &"', "
	  sql = sql & "otheroptions10 = "& sqlserverprefixn &"'"& tosql(otheroptions10,"Text") &"', "
	  sql = sql & "otheroptions11 = "& sqlserverprefixn &"'"& tosql(otheroptions11,"Text") &"', "
	  sql = sql & "otheroptions12 = "& sqlserverprefixn &"'"& tosql(otheroptions12,"Text") &"', "
	  sql = sql & "otheroptions13 = "& sqlserverprefixn &"'"& tosql(otheroptions13,"Text") &"', "
	  sql = sql & "otheroptions14 = "& sqlserverprefixn &"'"& tosql(otheroptions14,"Text") &"', "
	  sql = sql & "otheroptions15 = "& sqlserverprefixn &"'"& tosql(otheroptions15,"Text") &"', "
	  sql = sql & "otheroptions16 = "& sqlserverprefixn &"'"& tosql(otheroptions16,"Text") &"', "
	  sql = sql & "otheroptions17 = "& sqlserverprefixn &"'"& tosql(otheroptions17,"Text") &"', "
	  sql = sql & "otheroptions18 = "& sqlserverprefixn &"'"& tosql(otheroptions18,"Text") &"', "
	  sql = sql & "otheroptions19 = "& sqlserverprefixn &"'"& tosql(otheroptions19,"Text") &"', "
	  sql = sql & "otheroptions20 = "& sqlserverprefixn &"'"& tosql(otheroptions20,"Text") &"', "
	  sql = sql & "otheroptions21 = "& sqlserverprefixn &"'"& tosql(otheroptions21,"Text") &"', "
	  sql = sql & "otheroptions22 = "& sqlserverprefixn &"'"& tosql(otheroptions22,"Text") &"', "
	  sql = sql & "otheroptions23 = "& sqlserverprefixn &"'"& tosql(otheroptions23,"Text") &"', "
	  sql = sql & "otheroptions24 = "& sqlserverprefixn &"'"& tosql(otheroptions24,"Text") &"', "
	  sql = sql & "otheroptions25 = "& sqlserverprefixn &"'"& tosql(otheroptions25,"Text") &"', "
      sql = sql & "containername = "& sqlserverprefixn &"'"& tosql(containername,"Text") &"', "
      sql = sql & "containerdivname = "& sqlserverprefixn &"'"& tosql(divname,"Text") &"', "
      sql = sql & "labelfield = "& sqlserverprefixn &"'"& tosql(labelfield,"Text") &"' "
      sql = sql & "where id = "& id &" "
   else
      'do insert
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
	  sql = ""
	  if lcase(containername) <> "contentpage" then
	     sql = sql & "insert into containerbox (storematch,otheroptions1,otheroptions2,otheroptions3,otheroptions4,otheroptions5,otheroptions6,otheroptions7,otheroptions8,otheroptions9,otheroptions10,otheroptions11,otheroptions12,otheroptions13,otheroptions14,otheroptions15,otheroptions16,otheroptions17,otheroptions18,otheroptions19,otheroptions20,otheroptions21,otheroptions22,otheroptions23,otheroptions24,otheroptions25,containername,containerdivname,labelfield) Values("& sqlserverprefixn &"'"& tosql(currentxshopid,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions1,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions2,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions3,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions4,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions5,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions6,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions7,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions8,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions9,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions10,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions11,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions12,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions13,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions14,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions15,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions16,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions17,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions18,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions19,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions20,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions21,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions22,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions23,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions24,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions25,"Text") &"',"& sqlserverprefixn &"'"& tosql(containername,"Text") &"',"& sqlserverprefixn &"'"& tosql(divname,"Text") &"',"& sqlserverprefixn &"'"& tosql(labelfield,"Text") &"')"
	  else
	     sql = sql & "insert into containerbox (storematch,otheroptions1,otheroptions2,containername,containerdivname,labelfield) Values("& sqlserverprefixn &"'"& tosql(currentxshopid,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions1,"Text") &"',"& sqlserverprefixn &"'"& tosql(otheroptions2,"Text") &"',"& sqlserverprefixn &"'"& tosql(containername,"Text") &"',"& sqlserverprefixn &"'"& tosql(divname,"Text") &"',"& sqlserverprefixn &"'"& tosql(labelfield,"Text") &"')"
	  end if
   end if
   dbc.execute (sql)

   '700 - 2010.04.08 - get last containerbox id
   dim lastid
   if lcase(trim(id)) = "empty" then
      lastid = getlastcontainerboxid
   else
      lastid = id
   end if
   setsess containername & "lastid", lastid
   response.write getlang("langcontainermodsuccess")
end sub

sub deletecenterbox
   dim containerboxid,htmldivname
   containerboxid = cleanchars(request("id"))
   htmldivname = cleanchars(request("htmldivname"))
   
   dim containername
   
   if lcase(trim(containerboxid)) = "empty" then
      containername = "empty"
   else
      containername = getcontainername(containerboxid)
   end if
   
   if trim(containerboxid) = "" then exit sub
   if isnumeric(containerboxid) = false then exit sub
   
   dim sql
   if validcontainerid(containerboxid) = true then
      'do update
      sql = ""
      sql = sql & "delete from containerbox "
      sql = sql & "where id = "& containerboxid &" "

      '700 - 2010.06.16 - Enhancement: Layout manager - multi-store support
      GenLayoutMgrStorematchSQL "and", sql
   end if
   dbc.execute (sql)

   response.write "Container for "& containername &" deleted successfully!"

   dim divname
   divname = "centerbox"
%>
   <div>
   <input name="closecontainer" id="closecontainer" type="button" value="<%=GetLang("langcommonclose")%>" onclick="collapsecentereditbox('<%=htmldivname%>','<%=divname%>');"  >
   </div>
<%
end sub

sub getcentermaindetails
   dim newcontainername,id,htmldivname,divname
   
   newcontainername = cleanchars(request("newcontainername"))
   id = cleanchars(request("id"))
   htmldivname = cleanchars(request("divname"))

   divname = "centerbox"
   
   setsess "hpmgrnewcentercontainername",newcontainername
   loadcenterselections newcontainername,id,htmldivname,divname
end sub

sub gencenteremptytable(containerid,containerdivname,htmldivname)
   dim prefix,divname

   if trim(getsess("hpmgrnewcentercontainername")) <> "" then
      generatecentermainselection getsess("hpmgrnewcentercontainername"),htmldivname,containerid
   else   
      generatecentermainselection containername,htmldivname,containerid
   end if
   
   divname = "centerbox"
   prefix = divname & "empty"
%>
      <div name="<%=prefix%>containerresult" id="<%=prefix%>containerresult" class="errormsg"></div>
      <div>
         <input name="closecontainer" id="closecontainer" type="button" value="<%=GetLang("langcommonclose")%>" onclick="collapseeditbox('<%=htmldivname%>');"  >
      </div>
<%
end sub

sub generatecentermainselection (containername,htmldivname,containerid)
   setsess "hpmgrnewcentercontainername",""
   dim sectionArray, tempstring,sectioncnt,sectionArrays(999),sectionArrayValue,tempstring2

   tempstring = UCASE(centerboxselectionlanguage)
   tempstring2 = UCASE(centerboxselectionboxname)
   parserecord tempstring,sectionArrays,sectioncnt,","
   sectionArray = split(tempstring, ",")
   sectionArrayvalue = split(tempstring2, ",")
   if trim(containername) = "" then containername = "-"

   dim tempctrdesc
   tempctrdesc = getcontainernamedesc(containername,"centerbox")
   if trim(tempctrdesc) = "" then tempctrdesc = "&nbsp;"
%>
      <div class="sectitle"><%=GetLang("langhpmgrcurrentcontainer")%></div>
      <div class="secvaluedesc"><%=tempctrdesc%></div>
      
      <div class="sectitle"><%=GetLang("langhomepagemanagermainselect")%></div>
      <div class="secvaluedesc">
         <%GenerateSelectVHpMgr sectionArray, sectionArrayvalue, ucase(containername), "mainselection", sectioncnt, "SELECT", htmldivname, containerid, "getcentermaindetails"%>
	  </div>
<%
end sub

sub generatecenterbottommainfields (prefix,containerid,divname,htmldivname,savetype)
%>
      <div name="<%=prefix%>containerresult" id="<%=prefix%>containerresult" class="errormsg"></div>
      <div>
         <input name="addcontainer" id="addcontainer" type="button" value="<%=GetLang("langsavechagnes")%>" onclick="savesidebar('<%=containerid%>','<%=divname%>','<%=prefix%>','<%=savetype%>');"  >
         &nbsp;&nbsp;<input name="closecontainer" id="closecontainer" type="button" value="<%=GetLang("langcommonclose")%>" onclick="collapsecentereditbox('<%=htmldivname%>','<%=divname%>');"  >
      </div>
<%
end sub

sub gencentercontentpagetable(containerid,containerdivname,htmldivname)
   dim mainstatus,containername,labelfield,mainseqno,divname,prefix

   dim pageid,logoimage,message2,message
   gethomepagedetails pageid,logoimage,message2,message
   if pageid = "" then
      shopwriteerror "Your homepage content did not exist. <br />You need to create/edit a content record in Page Manager that have ""Use as homepage?"" set to Yes." & "<br />"
      divname = "centerbox"
%>
      <div>
         <input name="closecontainer" id="closecontainer" type="button" value="<%=GetLang("langcommonclose")%>" onclick="collapsecentereditbox('<%=htmldivname%>','<%=divname%>');"  >
      </div>
<%
      exit sub
   end if
   
   mainstatus = getotheroptions (containerdivname,"",containerid,"1")
   mainseqno = getotheroptions (containerdivname,"",containerid,"2")
   containername = getcontainername (containerid)
   labelfield = getlabelfield (containerdivname,"",containerid)
   
   if trim(getsess("hpmgrnewcentercontainername")) <> "" then
      generatecentermainselection getsess("hpmgrnewcentercontainername"),htmldivname,containerid
   else
      generatecentermainselection containername,htmldivname,containerid
   end if
   
   divname = "centerbox"
   prefix = divname & "contentpage"
   generatesidetopmainfields prefix,mainstatus,labelfield,mainseqno,"no",GetLang("langhpmgrlabelfield")

   dim uploadurl,imageurl
   uploadurl = "shopa_uploadpop.asp?form="& prefix &"uploadimageform&formfield="& prefix &"otheroptions3"
   if trim(logoimage)<>"" then
      imageurl = getactualfileslocation(request.ServerVariables("SCRIPT_NAME"), logoimage, GetLang("langcommonview"), "_blank", "yes")
   end if
%>
      <div class="sectitle"><%=GetLang("langhpmgrpageid")%></div>
      <div class="secvaluedesc"><%=pageid%></div>

      <form id="<%=prefix%>uploadimageform" name="<%=prefix%>uploadimageform">
      <div class="sectitle"><%=GetLang("langhpmgrlogoimage")%></div>
      <div class="secvaluedesc">
         <input name="<%=prefix%>otheroptions3" id="<%=prefix%>otheroptions3" type="text" size="30" maxlength="255" value="<%=logoimage%>" onclick="clearresult('<%=prefix%>containerresult');" >
         &nbsp;<a href="javascript:popUp('<%=uploadurl%>')"><%=GetLang("langupload")%></a><%if imageurl<>"" then response.write "&nbsp;" & imageurl%>
      </div>
      </form>

      <div class="sectitle"><%=GetLang("langcontentheader")%></div>
      <div class="secvaluedesc">
         <input name="<%=prefix%>otheroptions4" id="<%=prefix%>otheroptions4" type="text" size="30" maxlength="255" value="<%=message%>" onclick="clearresult('<%=prefix%>containerresult');" >
      </div>

      <div class="sectitle"><%=GetLang("langhpmgrdisplaytext")%></div>
      <div class="secvaluedesc">
         <textarea name="<%=prefix%>otheroptions5" id="<%=prefix%>otheroptions5" cols="30" rows="6" onclick="clearresult('<%=prefix%>containerresult');"><%=message2%></textarea>
         &nbsp;<a href="shopa_editcontent.asp?page=1&which=<%=pageid%>"><%=GetLang("langhpmgradvancededit")%></a>
      </div>
      
      <input name="<%=prefix%>otheroptions6" id="<%=prefix%>otheroptions6" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions7" id="<%=prefix%>otheroptions7" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions8" id="<%=prefix%>otheroptions8" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions9" id="<%=prefix%>otheroptions9" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions10" id="<%=prefix%>otheroptions10" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions11" id="<%=prefix%>otheroptions11" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions12" id="<%=prefix%>otheroptions12" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions13" id="<%=prefix%>otheroptions13" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions14" id="<%=prefix%>otheroptions14" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions15" id="<%=prefix%>otheroptions15" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions16" id="<%=prefix%>otheroptions16" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions17" id="<%=prefix%>otheroptions17" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions18" id="<%=prefix%>otheroptions18" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions19" id="<%=prefix%>otheroptions19" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions20" id="<%=prefix%>otheroptions20" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions21" id="<%=prefix%>otheroptions21" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions22" id="<%=prefix%>otheroptions22" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions23" id="<%=prefix%>otheroptions23" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions24" id="<%=prefix%>otheroptions24" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions25" id="<%=prefix%>otheroptions25" type="hidden" value="" />
      <input name="<%=prefix%>resizeimage" id="<%=prefix%>resizeimage" type="hidden" value="no" />
<%
   generatecenterbottommainfields prefix,containerid,divname,htmldivname,"savesidecentercontentpage"
end sub

'generate new products query table
sub gencenternewproductstable(containerid,containerdivname,htmldivname)
   dim mainstatus,containername,labelfield,mainseqno,divname,prefix,howmanytimes,randomflag,productduration
   
   mainstatus = getotheroptions (containerdivname,"",containerid,"1")
   mainseqno = getotheroptions (containerdivname,"",containerid,"2")
   containername = getcontainername (containerid)
   labelfield = getlabelfield (containerdivname,"",containerid)
   randomflag = getotheroptions (containerdivname,"",containerid,"3")
   howmanytimes = getconfig("xNewProductsfrontpagemaxrecords")
   productduration = getconfig("xNewProductDuration")
   
   if trim(getsess("hpmgrnewcentercontainername")) <> "" then
      generatecentermainselection getsess("hpmgrnewcentercontainername"),htmldivname,containerid
   else
      generatecentermainselection containername,htmldivname,containerid
   end if

   divname = "centerbox"
   prefix = divname & "newproducts"
   generatesidetopmainfields prefix,mainstatus,labelfield,mainseqno,"yes",GetLang("langhpmgrlabelfield")
%>
      <div class="sectitle"><%=GetLang("langhpmgrrandom")%></div>
      <div class="secvaluedesc">
         <select size="1" class="txtfielddropdown" name="<%=prefix%>otheroptions3" id="<%=prefix%>otheroptions3" onclick="clearresult('<%=prefix%>containerresult');" >
         <option value="">-- <%=GetLang("LangCommonSelect")%> --</option>
         <option value="Yes" <%if lcase(randomflag)="yes" then response.write "selected"%>><%=GetLang("LangCommonYes")%></option>
         <option value="No" <%if lcase(randomflag)<>"yes" then response.write "selected"%>><%=GetLang("LangCommonNo")%></option>
         </select>
      </div>
      
      <div class="sectitle"><%=GetLang("langhpmgrhowmanyitems")%></div>
      <div class="secvaluedesc">
         <input name="<%=prefix%>otheroptions4" id="<%=prefix%>otheroptions4" type="text" size="30" maxlength="100" value="<%=howmanytimes%>" onclick="clearresult('<%=prefix%>containerresult');">
      </div>

      <div class="sectitle"><%=GetLang("langhpmgrproductduration")%></div>
      <div class="secvaluedesc">
         <input name="<%=prefix%>otheroptions5" id="<%=prefix%>otheroptions5" type="text" size="30" maxlength="100" value="<%=productduration%>" onclick="clearresult('<%=prefix%>containerresult');">
      </div>
      
      <input name="<%=prefix%>otheroptions6" id="<%=prefix%>otheroptions6" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions7" id="<%=prefix%>otheroptions7" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions8" id="<%=prefix%>otheroptions8" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions9" id="<%=prefix%>otheroptions9" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions10" id="<%=prefix%>otheroptions10" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions11" id="<%=prefix%>otheroptions11" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions12" id="<%=prefix%>otheroptions12" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions13" id="<%=prefix%>otheroptions13" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions14" id="<%=prefix%>otheroptions14" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions15" id="<%=prefix%>otheroptions15" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions16" id="<%=prefix%>otheroptions16" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions17" id="<%=prefix%>otheroptions17" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions18" id="<%=prefix%>otheroptions18" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions19" id="<%=prefix%>otheroptions19" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions20" id="<%=prefix%>otheroptions20" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions21" id="<%=prefix%>otheroptions21" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions22" id="<%=prefix%>otheroptions22" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions23" id="<%=prefix%>otheroptions23" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions24" id="<%=prefix%>otheroptions24" type="hidden" value="" />
      <input name="<%=prefix%>otheroptions25" id="<%=prefix%>otheroptions25" type="hidden" value="" />
      <input name="<%=prefix%>resizeimage" id="<%=prefix%>resizeimage" type="hidden" value="no" />
<%
   generatecenterbottommainfields prefix,containerid,divname,htmldivname,"savesidecenternewproducts"
end sub
%>